#include<bits/stdc++.h>
using namespace std;
int main(){
	#define int long long
	const int MOD = 1e9+7;
	int m;
	cin>>m;
	int x[m];
	int y[m];
	int res[m];
	int zbir = 0;
	pair<int, int> par;
	for(int i=0;i<m;i++){
		cin>>x[i]>>y[i];
		if(i!=0){
		int q = abs(par.first - x[i]);
		int w = abs(par.second - y[i]);
		int e = q*w;
		e%=MOD;
		zbir+=e;
	}
		for(int j=0;j<=i;j++){
			int tr = 0;
			for(int k=0;k<=i;k++){ 	
				pair<int, int> tacka = {x[i], y[j]};
				int a = abs(tacka.first-x[k]);
				int b = abs(tacka.second-y[k]);
				int c = a*b;
				c%=MOD;
				tr+=c;
				tr%=MOD;
			}
			zbir = max(zbir, tr);
			if(zbir==tr) par = {x[i], y[j]};
			tr = 0;
			for(int k=0;k<=i;k++){
			pair<int, int> tacka = {x[j], y[i]}; 	
				int a = abs(tacka.first-x[k]);
				int b = abs(tacka.second-y[k]);
				int c = a*b;
				c%=MOD;
				tr+=c;
				tr%=MOD;
			}
			zbir = max(zbir, tr);
			if(zbir==tr) par = {x[j], y[i]};
		}
		res[i] = zbir;
	}
	for(int i=0;i<m;i++) cout<<res[i]<<endl;
}